# coding: utf-8

"""
    PeerTube

    # Introduction  The PeerTube API is built on HTTP(S). Our API is RESTful. It has predictable resource URLs. It returns HTTP response codes to indicate errors. It also accepts and returns JSON in the HTTP body. You can use your favorite HTTP/REST library for your programming language to use PeerTube. No official SDK is currently provided, but the spec API is fully compatible with [openapi-generator](https://github.com/OpenAPITools/openapi-generator/wiki/API-client-generator-HOWTO) which generates a client SDK in the language of your choice.  # Authentication  When you sign up for an account, you are given the possibility to generate sessions, and authenticate using this session token. One session token can currently be used at a time.  # Errors  The API uses standard HTTP status codes to indicate the success or failure of the API call. The body of the response will be JSON in the following format.  ``` {   \"code\": \"unauthorized_request\", // example inner error code   \"error\": \"Token is invalid.\" // example exposed error message } ```   # noqa: E501

    The version of the OpenAPI document: 2.1.0
    Generated by: https://openapi-generator.tech
"""


import pprint
import re  # noqa: F401

import six

from peertube.configuration import Configuration


class InlineObject3(object):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    """
    Attributes:
      openapi_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    openapi_types = {
        'videofile': 'file',
        'channel_id': 'float',
        'thumbnailfile': 'file',
        'previewfile': 'file',
        'privacy': 'VideoPrivacySet',
        'category': 'str',
        'licence': 'str',
        'language': 'str',
        'description': 'str',
        'wait_transcoding': 'str',
        'support': 'str',
        'nsfw': 'str',
        'name': 'str',
        'tags': 'list[str]',
        'comments_enabled': 'str',
        'originally_published_at': 'datetime',
        'schedule_update': 'VideoScheduledUpdate'
    }

    attribute_map = {
        'videofile': 'videofile',
        'channel_id': 'channelId',
        'thumbnailfile': 'thumbnailfile',
        'previewfile': 'previewfile',
        'privacy': 'privacy',
        'category': 'category',
        'licence': 'licence',
        'language': 'language',
        'description': 'description',
        'wait_transcoding': 'waitTranscoding',
        'support': 'support',
        'nsfw': 'nsfw',
        'name': 'name',
        'tags': 'tags',
        'comments_enabled': 'commentsEnabled',
        'originally_published_at': 'originallyPublishedAt',
        'schedule_update': 'scheduleUpdate'
    }

    def __init__(self, videofile=None, channel_id=None, thumbnailfile=None, previewfile=None, privacy=None, category=None, licence=None, language=None, description=None, wait_transcoding=None, support=None, nsfw=None, name=None, tags=None, comments_enabled=None, originally_published_at=None, schedule_update=None, local_vars_configuration=None):  # noqa: E501
        """InlineObject3 - a model defined in OpenAPI"""  # noqa: E501
        if local_vars_configuration is None:
            local_vars_configuration = Configuration()
        self.local_vars_configuration = local_vars_configuration

        self._videofile = None
        self._channel_id = None
        self._thumbnailfile = None
        self._previewfile = None
        self._privacy = None
        self._category = None
        self._licence = None
        self._language = None
        self._description = None
        self._wait_transcoding = None
        self._support = None
        self._nsfw = None
        self._name = None
        self._tags = None
        self._comments_enabled = None
        self._originally_published_at = None
        self._schedule_update = None
        self.discriminator = None

        self.videofile = videofile
        self.channel_id = channel_id
        if thumbnailfile is not None:
            self.thumbnailfile = thumbnailfile
        if previewfile is not None:
            self.previewfile = previewfile
        if privacy is not None:
            self.privacy = privacy
        if category is not None:
            self.category = category
        if licence is not None:
            self.licence = licence
        if language is not None:
            self.language = language
        if description is not None:
            self.description = description
        if wait_transcoding is not None:
            self.wait_transcoding = wait_transcoding
        if support is not None:
            self.support = support
        if nsfw is not None:
            self.nsfw = nsfw
        self.name = name
        if tags is not None:
            self.tags = tags
        if comments_enabled is not None:
            self.comments_enabled = comments_enabled
        if originally_published_at is not None:
            self.originally_published_at = originally_published_at
        if schedule_update is not None:
            self.schedule_update = schedule_update

    @property
    def videofile(self):
        """Gets the videofile of this InlineObject3.  # noqa: E501

        Video file  # noqa: E501

        :return: The videofile of this InlineObject3.  # noqa: E501
        :rtype: file
        """
        return self._videofile

    @videofile.setter
    def videofile(self, videofile):
        """Sets the videofile of this InlineObject3.

        Video file  # noqa: E501

        :param videofile: The videofile of this InlineObject3.  # noqa: E501
        :type: file
        """
        if self.local_vars_configuration.client_side_validation and videofile is None:  # noqa: E501
            raise ValueError("Invalid value for `videofile`, must not be `None`")  # noqa: E501

        self._videofile = videofile

    @property
    def channel_id(self):
        """Gets the channel_id of this InlineObject3.  # noqa: E501

        Channel id that will contain this video  # noqa: E501

        :return: The channel_id of this InlineObject3.  # noqa: E501
        :rtype: float
        """
        return self._channel_id

    @channel_id.setter
    def channel_id(self, channel_id):
        """Sets the channel_id of this InlineObject3.

        Channel id that will contain this video  # noqa: E501

        :param channel_id: The channel_id of this InlineObject3.  # noqa: E501
        :type: float
        """
        if self.local_vars_configuration.client_side_validation and channel_id is None:  # noqa: E501
            raise ValueError("Invalid value for `channel_id`, must not be `None`")  # noqa: E501

        self._channel_id = channel_id

    @property
    def thumbnailfile(self):
        """Gets the thumbnailfile of this InlineObject3.  # noqa: E501

        Video thumbnail file  # noqa: E501

        :return: The thumbnailfile of this InlineObject3.  # noqa: E501
        :rtype: file
        """
        return self._thumbnailfile

    @thumbnailfile.setter
    def thumbnailfile(self, thumbnailfile):
        """Sets the thumbnailfile of this InlineObject3.

        Video thumbnail file  # noqa: E501

        :param thumbnailfile: The thumbnailfile of this InlineObject3.  # noqa: E501
        :type: file
        """

        self._thumbnailfile = thumbnailfile

    @property
    def previewfile(self):
        """Gets the previewfile of this InlineObject3.  # noqa: E501

        Video preview file  # noqa: E501

        :return: The previewfile of this InlineObject3.  # noqa: E501
        :rtype: file
        """
        return self._previewfile

    @previewfile.setter
    def previewfile(self, previewfile):
        """Sets the previewfile of this InlineObject3.

        Video preview file  # noqa: E501

        :param previewfile: The previewfile of this InlineObject3.  # noqa: E501
        :type: file
        """

        self._previewfile = previewfile

    @property
    def privacy(self):
        """Gets the privacy of this InlineObject3.  # noqa: E501


        :return: The privacy of this InlineObject3.  # noqa: E501
        :rtype: VideoPrivacySet
        """
        return self._privacy

    @privacy.setter
    def privacy(self, privacy):
        """Sets the privacy of this InlineObject3.


        :param privacy: The privacy of this InlineObject3.  # noqa: E501
        :type: VideoPrivacySet
        """

        self._privacy = privacy

    @property
    def category(self):
        """Gets the category of this InlineObject3.  # noqa: E501

        Video category  # noqa: E501

        :return: The category of this InlineObject3.  # noqa: E501
        :rtype: str
        """
        return self._category

    @category.setter
    def category(self, category):
        """Sets the category of this InlineObject3.

        Video category  # noqa: E501

        :param category: The category of this InlineObject3.  # noqa: E501
        :type: str
        """

        self._category = category

    @property
    def licence(self):
        """Gets the licence of this InlineObject3.  # noqa: E501

        Video licence  # noqa: E501

        :return: The licence of this InlineObject3.  # noqa: E501
        :rtype: str
        """
        return self._licence

    @licence.setter
    def licence(self, licence):
        """Sets the licence of this InlineObject3.

        Video licence  # noqa: E501

        :param licence: The licence of this InlineObject3.  # noqa: E501
        :type: str
        """

        self._licence = licence

    @property
    def language(self):
        """Gets the language of this InlineObject3.  # noqa: E501

        Video language  # noqa: E501

        :return: The language of this InlineObject3.  # noqa: E501
        :rtype: str
        """
        return self._language

    @language.setter
    def language(self, language):
        """Sets the language of this InlineObject3.

        Video language  # noqa: E501

        :param language: The language of this InlineObject3.  # noqa: E501
        :type: str
        """

        self._language = language

    @property
    def description(self):
        """Gets the description of this InlineObject3.  # noqa: E501

        Video description  # noqa: E501

        :return: The description of this InlineObject3.  # noqa: E501
        :rtype: str
        """
        return self._description

    @description.setter
    def description(self, description):
        """Sets the description of this InlineObject3.

        Video description  # noqa: E501

        :param description: The description of this InlineObject3.  # noqa: E501
        :type: str
        """

        self._description = description

    @property
    def wait_transcoding(self):
        """Gets the wait_transcoding of this InlineObject3.  # noqa: E501

        Whether or not we wait transcoding before publish the video  # noqa: E501

        :return: The wait_transcoding of this InlineObject3.  # noqa: E501
        :rtype: str
        """
        return self._wait_transcoding

    @wait_transcoding.setter
    def wait_transcoding(self, wait_transcoding):
        """Sets the wait_transcoding of this InlineObject3.

        Whether or not we wait transcoding before publish the video  # noqa: E501

        :param wait_transcoding: The wait_transcoding of this InlineObject3.  # noqa: E501
        :type: str
        """

        self._wait_transcoding = wait_transcoding

    @property
    def support(self):
        """Gets the support of this InlineObject3.  # noqa: E501

        Text describing how to support the video uploader  # noqa: E501

        :return: The support of this InlineObject3.  # noqa: E501
        :rtype: str
        """
        return self._support

    @support.setter
    def support(self, support):
        """Sets the support of this InlineObject3.

        Text describing how to support the video uploader  # noqa: E501

        :param support: The support of this InlineObject3.  # noqa: E501
        :type: str
        """

        self._support = support

    @property
    def nsfw(self):
        """Gets the nsfw of this InlineObject3.  # noqa: E501

        Whether or not this video contains sensitive content  # noqa: E501

        :return: The nsfw of this InlineObject3.  # noqa: E501
        :rtype: str
        """
        return self._nsfw

    @nsfw.setter
    def nsfw(self, nsfw):
        """Sets the nsfw of this InlineObject3.

        Whether or not this video contains sensitive content  # noqa: E501

        :param nsfw: The nsfw of this InlineObject3.  # noqa: E501
        :type: str
        """

        self._nsfw = nsfw

    @property
    def name(self):
        """Gets the name of this InlineObject3.  # noqa: E501

        Video name  # noqa: E501

        :return: The name of this InlineObject3.  # noqa: E501
        :rtype: str
        """
        return self._name

    @name.setter
    def name(self, name):
        """Sets the name of this InlineObject3.

        Video name  # noqa: E501

        :param name: The name of this InlineObject3.  # noqa: E501
        :type: str
        """
        if self.local_vars_configuration.client_side_validation and name is None:  # noqa: E501
            raise ValueError("Invalid value for `name`, must not be `None`")  # noqa: E501

        self._name = name

    @property
    def tags(self):
        """Gets the tags of this InlineObject3.  # noqa: E501

        Video tags (maximum 5 tags each between 2 and 30 characters)  # noqa: E501

        :return: The tags of this InlineObject3.  # noqa: E501
        :rtype: list[str]
        """
        return self._tags

    @tags.setter
    def tags(self, tags):
        """Sets the tags of this InlineObject3.

        Video tags (maximum 5 tags each between 2 and 30 characters)  # noqa: E501

        :param tags: The tags of this InlineObject3.  # noqa: E501
        :type: list[str]
        """

        self._tags = tags

    @property
    def comments_enabled(self):
        """Gets the comments_enabled of this InlineObject3.  # noqa: E501

        Enable or disable comments for this video  # noqa: E501

        :return: The comments_enabled of this InlineObject3.  # noqa: E501
        :rtype: str
        """
        return self._comments_enabled

    @comments_enabled.setter
    def comments_enabled(self, comments_enabled):
        """Sets the comments_enabled of this InlineObject3.

        Enable or disable comments for this video  # noqa: E501

        :param comments_enabled: The comments_enabled of this InlineObject3.  # noqa: E501
        :type: str
        """

        self._comments_enabled = comments_enabled

    @property
    def originally_published_at(self):
        """Gets the originally_published_at of this InlineObject3.  # noqa: E501

        Date when the content was originally published  # noqa: E501

        :return: The originally_published_at of this InlineObject3.  # noqa: E501
        :rtype: datetime
        """
        return self._originally_published_at

    @originally_published_at.setter
    def originally_published_at(self, originally_published_at):
        """Sets the originally_published_at of this InlineObject3.

        Date when the content was originally published  # noqa: E501

        :param originally_published_at: The originally_published_at of this InlineObject3.  # noqa: E501
        :type: datetime
        """

        self._originally_published_at = originally_published_at

    @property
    def schedule_update(self):
        """Gets the schedule_update of this InlineObject3.  # noqa: E501


        :return: The schedule_update of this InlineObject3.  # noqa: E501
        :rtype: VideoScheduledUpdate
        """
        return self._schedule_update

    @schedule_update.setter
    def schedule_update(self, schedule_update):
        """Sets the schedule_update of this InlineObject3.


        :param schedule_update: The schedule_update of this InlineObject3.  # noqa: E501
        :type: VideoScheduledUpdate
        """

        self._schedule_update = schedule_update

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.openapi_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, InlineObject3):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, InlineObject3):
            return True

        return self.to_dict() != other.to_dict()
